import rclpy

from .data_interface import *


class DataSet:
    def __init__(self, **kwargs):
        self.__data = []
        {% for d in data %}
        self.__{{ d.name }} = {{ d.name|data_name }}Data(**kwargs)
        self.__data.append(self.__{{ d.name }})
        {%- endfor %}

    def __del__(self):
        {% for d in data %}del self.__{{ d.name }}
        {% endfor %}

    def destroy_nodes(self):
        {% for d in data %}self.__{{ d.name }}.destroy_node()
        {% endfor %}

    {% for d in data %}
    @property
    def {{ d.name }}(self) -> '{{ d.name|data_name }}Data':
        return self.__{{ d.name }}
    {% endfor %}

    def __getitem__(self, item):
        return getattr(self, item)

    def __iter__(self):
        return iter(self.__data)

    def __len__(self):
        return len(self.__data)

    def __nonzero__(self):
        return len(self.__data) > 0
